/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.HashMap;
import java.util.Vector;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class GrupoClase extends Composite {
	private Label labelGrupoMateria = null;
	private Combo comboMateriaClase = null;
	private ComboConId comboConIdMateriaClase = null;
	private Label labelParcial = null;
	private Combo comboParcial = null;
	private Table tableLista = null;
	private TableConId tableConIdLista = null;
	private Label lblVista;
	private Combo comboVista;
	private final Integer Normal=0;
	private final Integer Reducida=1;
	private final Integer Resumen=2;
	private final Integer Global=3;
	private Listener EditarCelda;
	public GrupoClase(Composite parent, int style) {super(parent, style);initialize();}
	public void actualizar(){
		comboConIdMateriaClase.rellenarMateriaClase(false);
		comboConIdMateriaClase.seleccionarId(MateriaClase.getIdMateriaClaseDeTrabajo());
		Parcial.rellenarParciales(comboParcial);
		comboParcial.select(Parcial.getParcial(Fecha.fechaDeTrabajo)-1);
		listarEstudiantes();
	}
	private void initialize() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		GridData gridDataTableLista = new GridData();
		gridDataTableLista.widthHint = 682;
		gridDataTableLista.horizontalSpan = 6;
		gridDataTableLista.verticalAlignment = GridData.FILL;
		gridDataTableLista.grabExcessHorizontalSpace = true;
		gridDataTableLista.grabExcessVerticalSpace = true;
		gridDataTableLista.horizontalAlignment = GridData.FILL;
		labelGrupoMateria = new Label(this, SWT.NONE);
		labelGrupoMateria.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_LabelGrupoMateria_Text"));
		labelGrupoMateria.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_LabelGrupoMateria_ToolTip"));
		GridLayout gridLayoutClase = new GridLayout();
		gridLayoutClase.horizontalSpacing = 2;
		gridLayoutClase.marginWidth = 2;
		gridLayoutClase.marginHeight = 2;
		gridLayoutClase.numColumns = 6;
		gridLayoutClase.verticalSpacing = 2;
		GridData gridDataClase = new GridData();
		gridDataClase.horizontalAlignment = GridData.FILL;
		gridDataClase.grabExcessHorizontalSpace = true;
		gridDataClase.grabExcessVerticalSpace = true;
		gridDataClase.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataClase);
		createComboGrupoMateria();
		this.setLayout(gridLayoutClase);
		this.setSize(new Point(685, 340));
		labelParcial = new Label(this, SWT.NONE);
		labelParcial.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_LabelParcial_Text"));
		labelParcial.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_LabelParcial_ToolTip"));
		createComboParcial();
		
		lblVista = new Label(this, SWT.NONE);
		lblVista.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblVista.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_LabelVista_Text"));
		lblVista.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_LabelVista_ToolTip"));
		
		comboVista = new Combo(this, SWT.READ_ONLY);
		comboVista.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (comboVista.getSelectionIndex()==PCuaderno.MiPCuaderno.grupoClase.Normal)
					tableLista.addListener(SWT.MouseUp, EditarCelda );
				else
					tableLista.removeListener(SWT.MouseUp, EditarCelda );
				if (comboVista.getSelectionIndex()==PCuaderno.MiPCuaderno.grupoClase.Global)
					comboParcial.setEnabled(false);
				else
					comboParcial.setEnabled(true);
				listarEstudiantes();
			}
		});
		GridData gd_comboVista = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_comboVista.widthHint = 100;
		comboVista.setLayoutData(gd_comboVista);
		comboVista.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_ComboVista_ToolTip"));
		comboVista.add(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_ComboVista_Element1"));
		comboVista.add(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_ComboVista_Element2"));
		comboVista.add(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_ComboVista_Element3"));
		comboVista.add(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_ComboVista_Element4"));
		comboVista.select(0);
		
		tableLista = new Table(this, SWT.BORDER);
		tableLista.setHeaderVisible(true);
		tableLista.setLayoutData(gridDataTableLista);
		tableLista.setLinesVisible(true);
		tableConIdLista = new TableConId(tableLista);
		this.listarEstudiantes();
		tableLista.update();
		tableLista.addListener(SWT.MouseExit, new Listener() {public void handleEvent(Event arg0) {tableLista.setToolTipText("");}});
		tableLista.addListener(SWT.MouseMove, new Listener() {
	    	public void handleEvent(Event event) {
	    		Rectangle clientArea = tableLista.getClientArea();
	    		Point puntero = new Point(event.x, event.y);
			    int fila = tableLista.getTopIndex();
			    while (fila < tableLista.getItemCount()) {
			    	boolean visible = false;
			        TableItem item = tableLista.getItem(fila);
			        for (int columna = 0; columna < tableLista.getColumnCount(); columna++) {
			        	Rectangle rect = item.getBounds(columna);
			            if (rect.contains(puntero)) {
			            	tableLista.setToolTipText(tableConIdLista.getEmergente().get(fila).get(columna));
			            }
			            if (!visible && rect.intersects(clientArea)) {visible = true;}
			        }
			        if (!visible) return;
			        fila++;
			    }
	    	}
	    });
		final TableEditor editor = new TableEditor(tableLista);
		editor.horizontalAlignment = SWT.CENTER;
		editor.grabHorizontal = true;
		EditarCelda = new Listener() {
			public void handleEvent(Event event) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Edit cell....");
				Rectangle clientArea = tableLista.getClientArea();
				Point puntero = new Point(event.x, event.y);
				int fila = tableLista.getTopIndex();
				while (fila < tableLista.getItemCount()) {
					boolean visible = false;
					final TableItem item = tableLista.getItem(fila);
					for (int columna = 0; columna < tableLista.getColumnCount(); columna++) {
						Rectangle rect = item.getBounds(columna);
						if (rect.contains(puntero)) {
							if (!tableConIdLista.getIdColumna().get(columna).equals("")) {
								final int fColumna = columna;
								final int fFila = fila;
								final String idEstudiante = tableConIdLista.getIdFila().get(fFila);
								final String idEvaluable = tableConIdLista.getIdColumna().get(fColumna);
								final String idEvalEvaluable = PCuaderno.MiPCuaderno.bbdd.consultarIdEvalEstudianteEvaluable(idEstudiante,idEvaluable);
								if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("idEvalEvaluable = "+idEvalEvaluable+" para Idfila = "+idEstudiante+" IdColumna = "+idEvaluable);
								if (idEvalEvaluable!=null) coloreaGrupoEvaluable(tableConIdLista,columna,fila,idEvalEvaluable);
								final Text text = new Text(tableLista, SWT.NONE);
								text.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Text_ToolTip"));
								Listener textListener = new Listener() {
									public void handleEvent(final Event e) {
										String idEvalNuevo=null;
										Vector<Vector<String>> estudiantesAfectados=null;
										switch (e.type) {
										case SWT.FocusOut:
											if (idEvalEvaluable!=null) estudiantesAfectados=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesEvalEvaluable(idEvalEvaluable);
											idEvalNuevo=editarNota(text.getText(),idEvaluable,idEstudiante);
											if (idEvalEvaluable==null) estudiantesAfectados=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesEvalEvaluable(idEvalNuevo);
											actualizaGrupoEvaluableTotales(tableConIdLista,fColumna,((idEvalEvaluable==null)?idEvalNuevo:idEvalEvaluable),estudiantesAfectados);
											text.dispose();
											break;
										case SWT.Traverse:
												switch (e.detail) {
													case SWT.TRAVERSE_RETURN:
														if (idEvalEvaluable!=null) estudiantesAfectados=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesEvalEvaluable(idEvalEvaluable);
														idEvalNuevo=editarNota(text.getText(),idEvaluable,idEstudiante);
														if (idEvalEvaluable==null) estudiantesAfectados=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesEvalEvaluable(idEvalNuevo);
														//System.out.println("estudiantes = "+estudiantesAfectados);
														actualizaGrupoEvaluableTotales(tableConIdLista,fColumna,((idEvalEvaluable==null)?idEvalNuevo:idEvalEvaluable),estudiantesAfectados);
													case SWT.TRAVERSE_ESCAPE:
														text.dispose();
														e.doit = false;
												}
												break;
										}
									}
								};
								text.addListener(SWT.FocusOut, textListener);
								text.addListener(SWT.Traverse, textListener);
								editor.setEditor(text, item, columna);
								text.setText(item.getText(columna));
								text.selectAll();
								text.setFocus();
								return;
							}
						}
						if (!visible && rect.intersects(clientArea)) {visible = true;}
					}
					if (!visible) return;
					fila++;
				}
			}
		};
		tableLista.addListener(SWT.MouseUp, EditarCelda );
		actualizar();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end");
	}
	private void createComboGrupoMateria() {
		GridData gridDataComboGrupoMateria = new GridData();
		gridDataComboGrupoMateria.grabExcessHorizontalSpace = true;
		gridDataComboGrupoMateria.verticalAlignment = GridData.CENTER;
		gridDataComboGrupoMateria.horizontalAlignment = GridData.FILL;
		gridDataComboGrupoMateria.minimumWidth = 200;
		comboMateriaClase = new Combo(this,SWT.READ_ONLY);
		comboMateriaClase.setLayoutData(gridDataComboGrupoMateria);
		comboMateriaClase
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						//System.out.println("comboGrupoMateria");
						MateriaClase.fijarMateriaClase(comboConIdMateriaClase.idSeleccionado());
						Parcial.rellenarParciales(comboParcial);
						comboParcial.select(Parcial.getParcial(Fecha.fechaDeTrabajo)-1);
						listarEstudiantes();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboMateriaClase.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_ComboMateriaClase_ToolTip"));
		comboConIdMateriaClase = new ComboConId(comboMateriaClase);
	}
	private void createComboParcial() {
		GridData gridDataComboParcial = new GridData();
		gridDataComboParcial.widthHint = 50;
		comboParcial = new Combo(this,SWT.READ_ONLY);
		comboParcial.setLayoutData(gridDataComboParcial);
		comboParcial
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						//System.out.println("comboParcial");
						Parcial.setParcialDeTrabajo(comboParcial.getSelectionIndex()+1);
						listarEstudiantes();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboParcial.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_ComboParcial_ToolTip"));
		Parcial.rellenarParciales(comboParcial);
	}
	private String editarNota(String texto, String idEvaluable, String idEstudiante){
		String idEvaluacion=PCuaderno.MiPCuaderno.bbdd.consultarIdEvalEstudianteEvaluable(idEstudiante,idEvaluable);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+texto+","+idEvaluable+","+idEstudiante+")");
		String nota;
		if (texto.equals("")){
			if (idEvaluacion!=null) {
				Vector<Vector<String>> evaluacion = PCuaderno.MiPCuaderno.bbdd.consultarEval(idEvaluacion);
				if (evaluacion.get(0).get(4).equals("")){
					PCuaderno.MiPCuaderno.bbdd.borrarEvalEvaluable(idEvaluacion);
					idEvaluacion=null;
				} else {
					if (evaluacion.get(0).get(2).equals("0")){
						PCuaderno.MiPCuaderno.bbdd.borrarEvalEvaluable(idEvaluacion);
						idEvaluacion=null;
					} else {
						PCuaderno.MiPCuaderno.bbdd.modificarNotaEvalEvaluable("0", idEvaluacion);
					}
				}
			}
		} else {
			nota=Numero.validarNumeroDecimal(texto,Numero.notaMax,true);
			if (nota!=null) {
				if (idEvaluacion==null) {
					idEvaluacion = PCuaderno.MiPCuaderno.bbdd.insertarEvalEstudianteEvaluable(idEstudiante, idEvaluable, nota);
				} else {
					PCuaderno.MiPCuaderno.bbdd.modificarNotaEvalEvaluable(nota, idEvaluacion);
				}
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+texto+","+idEvaluable+","+idEstudiante+") => idEval "+idEvaluacion);
		return idEvaluacion;
	}
	private void actualizaGrupoEvaluableTotales(TableConId tableConIdLista,int mColumna, String idEvalEvaluable, Vector<Vector<String>> estudiantes){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+tableConIdLista+","+mColumna+","+idEvalEvaluable+","+estudiantes+")");
		Vector<Vector<String>> evaluables=new Vector<Vector<String>>();
		Vector<Vector<String>> tiposEvaluable=new Vector<Vector<String>>();
		Color color=tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_BLACK);
		if (estudiantes!=null) if (estudiantes.size()>0) {
			evaluables=PCuaderno.MiPCuaderno.bbdd.consultarEvaluablesMateriaClaseParcial(comboConIdMateriaClase.idSeleccionado(),comboParcial.getSelectionIndex()+1);
			HashMap<String,Double> tipoMinimo = new HashMap<String,Double>();
			tiposEvaluable=PCuaderno.MiPCuaderno.bbdd.consultarTiposEvaluableMateriaClaseParcial(comboConIdMateriaClase.idSeleccionado(),comboParcial.getSelectionIndex()+1);
			if (tiposEvaluable!=null) {
				for (int i=0;i<tiposEvaluable.size();i++){
				    tipoMinimo.put(tiposEvaluable.get(i).get(0), Double.parseDouble(tiposEvaluable.get(i).get(4)));
				}
			}
			String notaBBDD=PCuaderno.MiPCuaderno.bbdd.consultarEvalNota(evaluables.get(mColumna-1).get(0),estudiantes.get(0).get(0));
			String notaEditada=null;
			if (notaBBDD!=null) {
				notaEditada=Numero.cadenaDecimal(Double.parseDouble(notaBBDD));
				if (!notaEditada.equals(""))
					color = tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
							((Numero.numeroDecimal(notaEditada)>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED));
			} else notaEditada="";
			for (int i=0;i<estudiantes.size();i++) {
				int nfila = tableConIdLista.getIdFila().indexOf(estudiantes.get(i).get(0));
				TableItem fila = tableConIdLista.getObjetoTable().getItem(nfila);
				fila.setText(mColumna, notaEditada);
				fila.setForeground(mColumna,color);
				tableConIdLista.getObjetoTable().getColumn(mColumna).pack();
				
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Estudiante = "+estudiantes.get(i).get(0)+":"+estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2));
				if (comboVista.getSelectionIndex()!=this.Resumen) {
				    Calendar fecha = Calendar.getInstance();
				    fecha.set(Integer.parseInt(evaluables.get(mColumna-1).get(1)),Integer.parseInt(evaluables.get(mColumna-1).get(2))-1,Integer.parseInt(evaluables.get(mColumna-1).get(3)),Integer.parseInt(evaluables.get(mColumna-1).get(4)),Integer.parseInt(evaluables.get(mColumna-1).get(5)));
					String idEvaluableEsRecuperado=evaluables.get(mColumna-1).get(12);
					Vector<Vector<String>> evaluableEsrecuperado = null;
					Calendar fechaRecuperado = null;
					if (idEvaluableEsRecuperado!=null) {
						evaluableEsrecuperado = PCuaderno.MiPCuaderno.bbdd.consultarEvaluable(idEvaluableEsRecuperado);
					    fechaRecuperado = Fecha.fecha(evaluableEsrecuperado.get(0).get(3),evaluableEsrecuperado.get(0).get(2),evaluableEsrecuperado.get(0).get(1));
					}
					tableConIdLista.getEmergente().get(nfila).set(mColumna,
				    		((evaluables.get(mColumna-1).get(12)!=null)?PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteRecuperacion")+" ("+Fecha.formaFechaDia(fechaRecuperado)+" "+evaluableEsrecuperado.get(0).get(5)+")\n":"")
							+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteEstudiantes")+" "+estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"
							+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteFin")+" "+Fecha.formaFechaDiaHora(fecha)+"\n"
							+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteTipo")+" "+
							((idEvaluableEsRecuperado==null)?evaluables.get(mColumna-1).get(11):evaluableEsrecuperado.get(0).get(10))+", "
							+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteReferencia")+" "+evaluables.get(mColumna-1).get(6)+", "
							+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergentePeso")+" "+
							((idEvaluableEsRecuperado==null)?Numero.cadenaEntero(Integer.parseInt(evaluables.get(mColumna-1).get(8))):Numero.cadenaEntero(Integer.parseInt(evaluableEsrecuperado.get(0).get(7))))+"\n"
							+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteEnunciado")+" "+evaluables.get(mColumna-1).get(7));
				} 
				
				Vector<Vector<String>> notas = null;
				//System.out.println("  /Consultando notas del estudiante("+estudiantes.get(i).get(0)+") materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
				notas=PCuaderno.MiPCuaderno.bbdd.consultarEvalEvaluablesPorEstudianteEnMateriaClaseParcial(
						estudiantes.get(i).get(0),
						comboConIdMateriaClase.idSeleccionado(),
						comboParcial.getSelectionIndex()+1);
				//System.out.println("  \\notas="+notas.size());
				HashMap<String,Double> sumaTipoEvaluable = new HashMap<String,Double>();
				HashMap<String,Double> pesoTipoEvaluable = new HashMap<String,Double>();
				Vector<String> tipoHayMenorMinimo = new Vector<String>();
				for (int j=0;j<notas.size();j++) {
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("nota "+j+":"+notas.get(j));
					int columna=tableConIdLista.getIdColumna().indexOf(notas.get(j).get(1));
					if (columna==mColumna && !notas.get(j).get(0).equals("")) {  // mColumna and not notaVirtual
						String texto=tableConIdLista.getEmergente().get(nfila).get(mColumna);
						tableConIdLista.getEmergente().get(nfila).set(mColumna,texto+"\n"
								+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteNota")+" "+Numero.cadenaDecimal(Double.parseDouble(notas.get(j).get(2)))+" "
								+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteGrupo")+" "+notas.get(j).get(4)+"\n"
								+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteObservaciones")+" "+notas.get(j).get(3));
					}	
					if (evaluables.get(columna-1).get(12)==null) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Nota estudiante "+estudiantes.get(i).get(0)+" Evaluable "+notas.get(j).get(1)+"( columna "+columna+"):"+notas.get(j).get(2));
						String tipo = evaluables.get(columna-1).get(9);
						Double nota = new Double(notas.get(j).get(2));
						Vector<Vector<String>> recuperaciones = PCuaderno.MiPCuaderno.bbdd.consultarEvaluableRecuperacionesDe(evaluables.get(columna-1).get(0));
						if (recuperaciones!=null && recuperaciones.size()>0) {
							if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Hay recueraciones...");
							for (int r=0;r<recuperaciones.size();r++) {
								String resultado = PCuaderno.MiPCuaderno.bbdd.consultarEvalNota(recuperaciones.get(r).get(0), estudiantes.get(i).get(0));
								//System.out.println("resultado="+resultado);
								if (resultado!=null) {
									Double nRecuperacion = new Double(resultado);
									if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Nota "+nota+" < "+nRecuperacion+" = "+(nota<nRecuperacion));
									if (nota<nRecuperacion) nota=nRecuperacion;
								}
							}
						}
	
						if (tipoHayMenorMinimo.indexOf(tipo)<0) 
							if (tipoMinimo.containsKey(tipo))
								if (nota<tipoMinimo.get(tipo)) tipoHayMenorMinimo.add(tipo);
						//System.out.println("tipo:"+tipo+" nota:"+nota+" minimo:"+tipoMinimo.get(tipo));
						Double peso = new Double(evaluables.get(columna-1).get(8));
						if (sumaTipoEvaluable.containsKey(tipo)){
							sumaTipoEvaluable.put(tipo, sumaTipoEvaluable.get(tipo)+(nota*peso));
							pesoTipoEvaluable.put(tipo, pesoTipoEvaluable.get(tipo)+peso);
						} else {
							sumaTipoEvaluable.put(tipo, (nota*peso)); 
							pesoTipoEvaluable.put(tipo, peso);
						}
						//System.out.println("idEvalAct nota("+notas.get(j).get(0)+") != ("+idEvalEvaluable+") "+!notas.get(j).get(0).equals(idEvalEvaluable)+" mNota ("+mNota+") "+!mNota.equals("")+" tipo ("+tipo+") suma = "+sumaTipoEvaluable.get(tipo)+" peso = "+pesoTipoEvaluable.get(tipo));
					} else {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("RECUPERACION Nota estudiante "+estudiantes.get(i).get(0)+" Evaluable "+notas.get(j).get(1)+"( columna "+columna+"):"+notas.get(j).get(2));
						boolean esta=false;
						for (int k=0;k<notas.size();k++) if (notas.get(k).get(1).equals(evaluables.get(columna-1).get(12))) esta=true;
						if (!esta) {
							Vector<String> notaVirtual = new Vector<String>();
							notaVirtual.add("");
							notaVirtual.add(evaluables.get(columna-1).get(12));
							notaVirtual.add(notas.get(j).get(2));
							notas.add(notaVirtual); // primera cadena = "" ==> notaVirtual (sin nota en el elemento recuperado)
						}
					}
				}
				Double sumaTipoEvaluableTotal = new Double(0);
				Double pesoTipoEvaluableTotal = new Double(0);
				boolean tieneAlgunaNota = false;
				//System.out.println("  tipos="+tiposEvaluable.size());
				for (int j=0;j<tiposEvaluable.size();j++){
					int columna=tableConIdLista.getObjetoTable().getColumnCount()-tiposEvaluable.size()-1+j;
					if (sumaTipoEvaluable.containsKey(tiposEvaluable.get(j).get(0))) {
						Double notaTipo = sumaTipoEvaluable.get(tiposEvaluable.get(j).get(0))/pesoTipoEvaluable.get(tiposEvaluable.get(j).get(0));
						if (tipoHayMenorMinimo.indexOf(tiposEvaluable.get(j).get(0))<0) {
							//System.out.println("Poniendo a '"+Numero.cadena(notaTip)+"' tipo "+tiposEvaluable.get(j).get(0));
							fila.setText(columna,Numero.cadena(notaTipo));
						    fila.setForeground(columna,
						    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
						    				((notaTipo>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
						    		));
						} else {
							fila.setText(columna,"-");
							fila.setForeground(columna,
					    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
					    				SWT.COLOR_RED
					    		));						
						}
						Double peso = new Double(tiposEvaluable.get(j).get(3));
						sumaTipoEvaluableTotal=sumaTipoEvaluableTotal+(notaTipo*peso);
						pesoTipoEvaluableTotal=pesoTipoEvaluableTotal+peso;
						//System.out.println("Total tipo ("+tiposEvaluable.get(j).get(0)+") suma = "+sumaTipoEvaluableTotal+" peso = "+pesoTipoEvaluableTotal);
						tieneAlgunaNota=true;
					} else {
						//System.out.println("Poniendo a '' tipo "+tiposEvaluable.get(j).get(0));
						fila.setText(columna,"");
						fila.setForeground(columna,tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_BLACK));					
					}
				}
				int columna=tableConIdLista.getObjetoTable().getColumnCount()-1;
				if (tieneAlgunaNota) {
					double notaTotal=sumaTipoEvaluableTotal/pesoTipoEvaluableTotal;
					if (tipoHayMenorMinimo.size()==0) {
						fila.setText(columna,Numero.cadena(notaTotal));
						fila.setForeground(columna,
				    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
				    				((notaTotal>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
				    		));
					} else {
						fila.setText(columna,"-");
						fila.setForeground(columna,
				    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
				    				SWT.COLOR_RED
				    		));
						
					}
				} else {
					fila.setText(columna,"");
					fila.setForeground(columna,tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_BLACK));					
				}
			}
		}
	}
	private void coloreaGrupoEvaluable(TableConId tableConIdLista, int columna, int fila, String idEvalEvaluable){
		Vector<Vector<String>> tabla = PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesEvalEvaluable(idEvalEvaluable);
		//System.out.println("Coloreando grupo Evaluable columna = "+columna+" fila = "+fila+" Evaluable = "+idEvalEvaluable);
		for (int i=0;i<tabla.size();i++) {
			int ifila = tableConIdLista.getIdFila().indexOf(tabla.get(i).get(0));
			tableConIdLista.getObjetoTable().getItem(ifila).setForeground(columna,
					tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_GRAY));
		}
	}
	public void listarEstudiantes(){
		if (comboVista.getSelectionIndex()==this.Global)
			listarEstudiantesGlobal();
		else
			listarEstudiantesNota();
	}
	public void listarEstudiantesNota(){
		Integer vista=comboVista.getSelectionIndex();
		Vector<Vector<String>> estudiantes=new Vector<Vector<String>>();
		Vector<Vector<String>> evaluables=new Vector<Vector<String>>();
		Vector<Vector<String>> tiposEvaluable=new Vector<Vector<String>>();
		TableColumn tableColumnLista = null;
		tableConIdLista.borrar();
		//System.out.println("\n\nActualizandoTabla---------------------------------------------------------------------------------");
		//System.out.println(" Limpiado datos... filas("+tableConIdLista.getObjetoTable().getItemCount()+") columnas("+tableConIdLista.getObjetoTable().getColumnCount()+") IdColumna("+tableConIdLista.getIdColumna().size()+") IdFila("+tableConIdLista.getIdFila().size()+")");
		//System.out.println(" Añadiendo datos...");
		if (comboConIdMateriaClase.idSeleccionado()!=null) {
			//System.out.println("  /Consultando estudiantes...Materia "+comboConIdGrupoMateria.idSeleccionado());
			estudiantes=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesMateriaClase(comboConIdMateriaClase.idSeleccionado(),null);
			//System.out.println("  \\Estudiantes="+estudiantes.size());
			if (estudiantes.size()>0) {
			    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
			    tableColumnLista.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_Text"));
			    tableConIdLista.getIdColumna().add("");
				//System.out.println("  /Consultando Evaluables de la materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
				evaluables=PCuaderno.MiPCuaderno.bbdd.consultarEvaluablesMateriaClaseParcial(
						comboConIdMateriaClase.idSeleccionado(),
						comboParcial.getSelectionIndex()+1);
				//System.out.println("  \\Evaluables="+evaluables.size());
				if (evaluables!=null) {
					for (int i=0;i<evaluables.size();i++){
						if (vista!=this.Resumen) {
						    Calendar fecha = Calendar.getInstance();
						    fecha.set(Integer.parseInt(evaluables.get(i).get(1)),Integer.parseInt(evaluables.get(i).get(2))-1,Integer.parseInt(evaluables.get(i).get(3)),Integer.parseInt(evaluables.get(i).get(4)),Integer.parseInt(evaluables.get(i).get(5)));
						    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
						    if (vista==this.Reducida) {
								String idEvaluableEsRecuperado=evaluables.get(i).get(12);
								if (idEvaluableEsRecuperado==null)
									tableColumnLista.setText(evaluables.get(i).get(10).substring(0, 1));
								else {
									Vector<Vector<String>> evaluableEsrecuperado = PCuaderno.MiPCuaderno.bbdd.consultarEvaluable(idEvaluableEsRecuperado);
									tableColumnLista.setText(evaluableEsrecuperado.get(0).get(9).substring(0, 1));
								}
						    } else 
						    	tableColumnLista.setText((evaluables.get(i).get(6).equals(""))?"...":evaluables.get(i).get(6));

							String idEvaluableEsRecuperado=evaluables.get(i).get(12);
							Vector<Vector<String>> evaluableEsrecuperado = null;
							Calendar fechaRecuperado = null;
							if (idEvaluableEsRecuperado!=null) {
								evaluableEsrecuperado = PCuaderno.MiPCuaderno.bbdd.consultarEvaluable(idEvaluableEsRecuperado);
							    fechaRecuperado = Fecha.fecha(evaluableEsrecuperado.get(0).get(3),evaluableEsrecuperado.get(0).get(2),evaluableEsrecuperado.get(0).get(1));
							}
						    tableColumnLista.setToolTipText(
						    		((evaluables.get(i).get(12)!=null)?PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipRecuperacion")+" ("+Fecha.formaFechaDia(fechaRecuperado)+" "+evaluableEsrecuperado.get(0).get(5)+")\n":"")+
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipFin")+" "+Fecha.formaFechaDiaHora(fecha)+"\n"+
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipTipo")+" "+
						    		((idEvaluableEsRecuperado==null)?evaluables.get(i).get(11):evaluableEsrecuperado.get(0).get(10))+", "+
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipReferencia")+" "+evaluables.get(i).get(6)+", "+
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipPesoTipo")+" "+
						    		((idEvaluableEsRecuperado==null)?Numero.cadenaEntero(Integer.parseInt(evaluables.get(i).get(8))):Numero.cadenaEntero(Integer.parseInt(evaluableEsrecuperado.get(0).get(7))))+"\n"+
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipEnunciado")+" "+evaluables.get(i).get(7));
						    tableColumnLista.setWidth(80);
						    tableColumnLista.pack();
						    tableColumnLista.setAlignment(SWT.CENTER);
						}
					    tableConIdLista.getIdColumna().add(evaluables.get(i).get(0));
						//System.out.println("  Añadiendo columna Evaluable "+evaluables.get(i).get(0)+":"+evaluables.get(i).get(6));
					}
				}
				HashMap<String,Double> tipoMinimo = new HashMap<String,Double>();
				//System.out.println("  /Consultando tipos de Evaluable de la materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
				tiposEvaluable=PCuaderno.MiPCuaderno.bbdd.consultarTiposEvaluableMateriaClaseParcial(
						comboConIdMateriaClase.idSeleccionado(),
						comboParcial.getSelectionIndex()+1);
				//System.out.println("  \\tipos="+tiposEvaluable.size());
				if (tiposEvaluable!=null) {
					for (int i=0;i<tiposEvaluable.size();i++){
					    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
					    tableColumnLista.setText(tiposEvaluable.get(i).get(1));
					    tableColumnLista.setToolTipText(
					    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipEnunciado")+" "+tiposEvaluable.get(i).get(2)+"\n"+
					    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipMinimo")+" "+Numero.cadenaDecimal(Double.parseDouble(tiposEvaluable.get(i).get(4)))+"\n"+
					    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipPesoTotal")+" "+Numero.cadenaEntero(Integer.parseInt(tiposEvaluable.get(i).get(3))));
					    tableConIdLista.getIdColumna().add("");
						//System.out.println("  Añadiendo columna tipo Evaluable "+evaluables.get(i).get(0)+":"+evaluables.get(i).get(6));
					    tableColumnLista.setWidth(80);
					    tableColumnLista.pack();
					    tableColumnLista.setAlignment(SWT.CENTER);
						//System.out.println("tipo:"+tiposEvaluable.get(i).get(0)+" minimo:"+Double.parseDouble(tiposEvaluable.get(i).get(4)));
						tipoMinimo.put(tiposEvaluable.get(i).get(0), Double.parseDouble(tiposEvaluable.get(i).get(4)));
					}
				}
			    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
			    tableColumnLista.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_Cabecera_Total"));
			    tableConIdLista.getIdColumna().add("");
			    tableColumnLista.pack();
			    tableColumnLista.setAlignment(SWT.LEFT);
				Vector<String> emergenteFila;
				for (int i=0;i<estudiantes.size();i++){
					//System.out.println("  Creando Fila estudiante: "+estudiantes.get(i).get(0));
					emergenteFila = new Vector<String>();
					tableConIdLista.getIdFila().addElement(estudiantes.get(i).get(0));
					TableItem fila = new TableItem(tableConIdLista.getObjetoTable(), SWT.NONE);
					String columnas[] = new String[tableConIdLista.getIdColumna().size()];
					for (int j=0;j<columnas.length;j++) {
						columnas[j]="";
						if (j==0)  {
							String emergenteCelda=
									estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"
									+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteDatos")+" "+((estudiantes.get(i).get(3)!=null)?estudiantes.get(i).get(3):"");
							emergenteFila.addElement(emergenteCelda);
						} else if (j<=((evaluables!=null)?evaluables.size():0)) {
							if (vista!=this.Resumen) {
							    Calendar fecha = Calendar.getInstance();
							    fecha.set(Integer.parseInt(evaluables.get(j-1).get(1)),Integer.parseInt(evaluables.get(j-1).get(2))-1,Integer.parseInt(evaluables.get(j-1).get(3)),Integer.parseInt(evaluables.get(j-1).get(4)),Integer.parseInt(evaluables.get(j-1).get(5)));
								String idEvaluableEsRecuperado=evaluables.get(j-1).get(12);
								Vector<Vector<String>> evaluableEsrecuperado = null;
								Calendar fechaRecuperado = null;
								if (idEvaluableEsRecuperado!=null) {
									evaluableEsrecuperado = PCuaderno.MiPCuaderno.bbdd.consultarEvaluable(idEvaluableEsRecuperado);
								    fechaRecuperado = Fecha.fecha(evaluableEsrecuperado.get(0).get(3),evaluableEsrecuperado.get(0).get(2),evaluableEsrecuperado.get(0).get(1));
								}
								emergenteFila.addElement(
							    		((evaluables.get(j-1).get(12)!=null)?PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteRecuperacion")+" ("+Fecha.formaFechaDia(fechaRecuperado)+" "+evaluableEsrecuperado.get(0).get(5)+")\n":"")
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteEstudiantes")+" "+estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteFin")+" "+Fecha.formaFechaDiaHora(fecha)+"\n"
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteTipo")+" "+
										((idEvaluableEsRecuperado==null)?evaluables.get(j-1).get(11):evaluableEsrecuperado.get(0).get(10))+", "
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteReferencia")+" "+evaluables.get(j-1).get(6)+", "
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergentePeso")+" "+
										((idEvaluableEsRecuperado==null)?Numero.cadenaEntero(Integer.parseInt(evaluables.get(j-1).get(8))):Numero.cadenaEntero(Integer.parseInt(evaluableEsrecuperado.get(0).get(7))))+"\n"
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteEnunciado")+" "+evaluables.get(j-1).get(7));
							} 
						} else if (j==columnas.length-1) {emergenteFila.addElement(emergenteFila.get(0));
						} else {emergenteFila.addElement("");}
					}
					columnas[0]=estudiantes.get(i).get(1)+", "+estudiantes.get(i).get(2);
					fila.setText(columnas);
					Vector<Vector<String>> notas = null;
					//System.out.println("  /Consultando notas del estudiante("+estudiantes.get(i).get(0)+") materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
					notas=PCuaderno.MiPCuaderno.bbdd.consultarEvalEvaluablesPorEstudianteEnMateriaClaseParcial(
							estudiantes.get(i).get(0),
							comboConIdMateriaClase.idSeleccionado(),
							comboParcial.getSelectionIndex()+1);
					//System.out.println("  \\notas="+notas.size());
					HashMap<String,Double> sumaTipoEvaluable = new HashMap<String,Double>();
					HashMap<String,Double> pesoTipoEvaluable = new HashMap<String,Double>();
					Vector<String> tipoHayMenorMinimo = new Vector<String>();
					if (notas!=null){
						//System.out.println(tableConIdLista.getIdColumna().toString());
						for (int j=0;j<notas.size();j++) {
							int columna=tableConIdLista.getIdColumna().indexOf(notas.get(j).get(1));
							//System.out.println("   Nota estudiante "+estudiantes.get(i).get(0)+" evaluable "+notas.get(j).get(1)+"( columna "+columna+"):"+notas.get(j).get(2));
							if (vista!=this.Resumen && !notas.get(j).get(0).equals("")) { // NO view resumen and not notaVirtual 
								if (vista==Reducida)
									fila.setText(columna,Numero.cadenaEntero(Double.parseDouble(notas.get(j).get(2))));
								else
									fila.setText(columna,Numero.cadenaDecimal(Double.parseDouble(notas.get(j).get(2))));
								tableConIdLista.getObjetoTable().getColumn(columna).pack();
							    fila.setForeground(columna,
							    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
							    				((Float.parseFloat(notas.get(j).get(2))>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)));
								emergenteFila.set(columna,emergenteFila.get(columna)+"\n"
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteNota")+" "+Numero.cadenaDecimal(Double.parseDouble(notas.get(j).get(2)))+" "
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteGrupo")+" "+notas.get(j).get(4)+"\n"
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteObservaciones")+" "+notas.get(j).get(3));
							}
							if (evaluables.get(columna-1).get(12)==null) {
								Double nota = new Double(notas.get(j).get(2));
								Vector<Vector<String>> recuperaciones = PCuaderno.MiPCuaderno.bbdd.consultarEvaluableRecuperacionesDe(evaluables.get(columna-1).get(0));
								if (recuperaciones!=null && recuperaciones.size()>0) {
									for (int r=0;r<recuperaciones.size();r++) {
										String resultado = PCuaderno.MiPCuaderno.bbdd.consultarEvalNota(recuperaciones.get(r).get(0), estudiantes.get(i).get(0));
										//System.out.println("resultado="+resultado);
										if (resultado!=null) {
											Double nRecuperacion = new Double(resultado);
											//System.out.println("Nota "+nota+" < "+nRecuperacion+" = "+(nota<nRecuperacion));
											if (nota<nRecuperacion) nota=nRecuperacion;
										}
									}
								}
								String tipo = evaluables.get(columna-1).get(9);
								//System.out.println("tipo:"+tipo+" nota:"+nota+" minimo:"+tipoMinimo.get(tipo));
								if (tipoHayMenorMinimo.indexOf(tipo)<0) 
									if (tipoMinimo.containsKey(tipo))
										if (nota<tipoMinimo.get(tipo)) tipoHayMenorMinimo.add(tipo);
								Double peso = new Double(evaluables.get(columna-1).get(8));
								if (sumaTipoEvaluable.containsKey(tipo)){
									sumaTipoEvaluable.put(tipo, sumaTipoEvaluable.get(tipo)+(nota*peso));
									pesoTipoEvaluable.put(tipo, pesoTipoEvaluable.get(tipo)+peso);
								} else {
									sumaTipoEvaluable.put(tipo, (nota*peso)); 
									pesoTipoEvaluable.put(tipo, peso);
								}
							} else {
								boolean esta=false;
								for (int k=0;k<notas.size();k++) if (notas.get(k).get(1).equals(evaluables.get(columna-1).get(12))) esta=true;
								if (!esta) {
									Vector<String> notaVirtual = new Vector<String>();
									notaVirtual.add("");
									notaVirtual.add(evaluables.get(columna-1).get(12));
									notaVirtual.add(notas.get(j).get(2));
									notas.add(notaVirtual); // primera cadena = "" ==> notaVirtual (sin nota en el elemento recuperado)
								}
							}
						}
							//System.out.println("tipo ("+tipo+") suma = "+sumaTipoEvaluable.get(tipo)+" peso = "+pesoTipoEvaluable.get(tipo));
					}
					Double sumaTipoEvaluableTotal = new Double(0);
					Double pesoTipoEvaluableTotal = new Double(0);
					boolean tieneAlgunaNota = false;
					if (tiposEvaluable!=null) {
						for (int j=0;j<tiposEvaluable.size();j++){
							int columna=tableConIdLista.getObjetoTable().getColumnCount()-tiposEvaluable.size()-1+j;
							if (sumaTipoEvaluable.containsKey(tiposEvaluable.get(j).get(0))) {
								Double nota = sumaTipoEvaluable.get(tiposEvaluable.get(j).get(0))/pesoTipoEvaluable.get(tiposEvaluable.get(j).get(0));
								if (tipoHayMenorMinimo.indexOf(tiposEvaluable.get(j).get(0))<0) {
									fila.setText(columna,Numero.cadena(nota));
								    fila.setForeground(columna,
								    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
								    				((nota>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
								    		));
								} else {
									fila.setText(columna,"-");
									fila.setForeground(columna,
							    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
							    				SWT.COLOR_RED
							    		));
								}
								Double peso = new Double(tiposEvaluable.get(j).get(3));
								sumaTipoEvaluableTotal=sumaTipoEvaluableTotal+(nota*peso);
								pesoTipoEvaluableTotal=pesoTipoEvaluableTotal+peso;
								//System.out.println("Total tipo ("+tiposEvaluable.get(j).get(0)+") suma = "+sumaTipoEvaluableTotal+" peso = "+pesoTipoEvaluableTotal);
								tieneAlgunaNota=true;
							}
							emergenteFila.set(columna,
									PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteEstudiantes")+" "+estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"+
									PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteTipo")+" "+tiposEvaluable.get(j).get(2)+"\n"+
									PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergentePesoTotal")+" "+Numero.cadenaEntero(Integer.parseInt(tiposEvaluable.get(j).get(3))));
						}
					}
					int columna=tableConIdLista.getObjetoTable().getColumnCount()-1;
					if (tieneAlgunaNota) {
						double notaTotal=sumaTipoEvaluableTotal/pesoTipoEvaluableTotal;
						if (tipoHayMenorMinimo.size()==0) {
							fila.setText(columna,Numero.cadena(notaTotal));
							fila.setForeground(columna,
					    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
					    				((notaTotal>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
					    		));
						} else {
							fila.setText(columna,"-");
							fila.setForeground(columna,
					    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
					    				SWT.COLOR_RED
					    		));
							
						}
					}
					tableConIdLista.getEmergente().add(emergenteFila);
				}
				tableConIdLista.getObjetoTable().getColumn(0).pack();
			}
		}
	}
	public void listarEstudiantesGlobal(){
		Vector<Vector<String>> estudiantes=new Vector<Vector<String>>();
		TableColumn tableColumnLista = null;
		tableConIdLista.borrar();
		//System.out.println("\n\nActualizandoTabla---------------------------------------------------------------------------------");
		//System.out.println(" Limpiado datos... filas("+tableConIdLista.getObjetoTable().getItemCount()+") columnas("+tableConIdLista.getObjetoTable().getColumnCount()+") IdColumna("+tableConIdLista.getIdColumna().size()+") IdFila("+tableConIdLista.getIdFila().size()+")");
		//System.out.println(" Añadiendo datos...");
		if (comboConIdMateriaClase.idSeleccionado()!=null) {
			//System.out.println("  /Consultando estudiantes...Materia "+comboConIdGrupoMateria.idSeleccionado());
			estudiantes=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesMateriaClase(comboConIdMateriaClase.idSeleccionado(),null);
			//System.out.println("  \\Estudiantes="+estudiantes.size());
			if (estudiantes.size()>0) {
			    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
			    tableColumnLista.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_Text"));
			    tableConIdLista.getIdColumna().add("");
				for (int i=0;i<estudiantes.size();i++){
					//System.out.println("  Creando Fila estudiante: "+estudiantes.get(i).get(0));
					Vector<String> emergenteFila = new Vector<String>();
					tableConIdLista.getIdFila().addElement(estudiantes.get(i).get(0));
					TableItem fila = new TableItem(tableConIdLista.getObjetoTable(), SWT.NONE);
					String columnas[] = new String[1];
					String emergenteCelda=
						estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"
						+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteDatos")+" "+((estudiantes.get(i).get(3)!=null)?estudiantes.get(i).get(3):"");
					emergenteFila.addElement(emergenteCelda);
					columnas[0]=estudiantes.get(i).get(1)+", "+estudiantes.get(i).get(2);
					fila.setText(columnas);
					tableConIdLista.getEmergente().add(emergenteFila);
				}
			    Vector<Boolean> hayParcialSuspenso = new Vector<Boolean>();
			    Vector<Double> sumaParciales = new Vector<Double>();
			    Vector<Integer> notasParciales = new Vector<Integer>();
			    for (int i=0;i<estudiantes.size();i++){
			    	hayParcialSuspenso.add(new Boolean(false));
			    	sumaParciales.add(0d);
			    	notasParciales.add(0);
			    }
			    for (int nparcial=1;nparcial<=Parcial.numeroParciales();nparcial++) {
					Vector<Vector<String>> evaluables=new Vector<Vector<String>>();
					Vector<Vector<String>> tiposEvaluable=new Vector<Vector<String>>();
					evaluables=PCuaderno.MiPCuaderno.bbdd.consultarEvaluablesMateriaClaseParcial(
							comboConIdMateriaClase.idSeleccionado(),
							nparcial);
					Vector<String> idEvaluables = new Vector<String>(); 
					//System.out.println("  \\Evaluables="+evaluables.size());
					if (evaluables!=null) {
						for (int i=0;i<evaluables.size();i++){
						    idEvaluables.add(evaluables.get(i).get(0));
							//System.out.println("  Añadiendo columna Evaluable "+evaluables.get(i).get(0)+":"+evaluables.get(i).get(6));
						}
					}
					HashMap<String,Double> tipoMinimo = new HashMap<String,Double>();
					//System.out.println("  /Consultando tipos de Evaluable de la materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
					tiposEvaluable=PCuaderno.MiPCuaderno.bbdd.consultarTiposEvaluableMateriaClaseParcial(
							comboConIdMateriaClase.idSeleccionado(),
							nparcial);
					//System.out.println("  \\tipos="+tiposEvaluable.size());
					if (tiposEvaluable!=null) {
						for (int i=0;i<tiposEvaluable.size();i++){
						    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
						    tableColumnLista.setText(tiposEvaluable.get(i).get(1));
						    tableColumnLista.setToolTipText(
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipEnunciado")+" "+tiposEvaluable.get(i).get(2)+"\n"+
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipMinimo")+" "+Numero.cadenaDecimal(Double.parseDouble(tiposEvaluable.get(i).get(4)))+"\n"+
						    		PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_ToolTipPesoTotal")+" "+Numero.cadenaEntero(Integer.parseInt(tiposEvaluable.get(i).get(3))));
						    tableConIdLista.getIdColumna().add("");
							//System.out.println("  Añadiendo columna tipo Evaluable "+evaluables.get(i).get(0)+":"+evaluables.get(i).get(6));
						    tableColumnLista.setWidth(80);
						    tableColumnLista.pack();
						    tableColumnLista.setAlignment(SWT.CENTER);
							//System.out.println("tipo:"+tiposEvaluable.get(i).get(0)+" minimo:"+Double.parseDouble(tiposEvaluable.get(i).get(4)));
							tipoMinimo.put(tiposEvaluable.get(i).get(0), Double.parseDouble(tiposEvaluable.get(i).get(4)));
						}
					}
				    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE); // Tparcial
				    tableColumnLista.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_Cabecera_Parcial")+" "+String.valueOf(nparcial));
				    tableConIdLista.getIdColumna().add("");
				    tableColumnLista.pack();
				    tableColumnLista.setAlignment(SWT.CENTER);
				    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE); // separador
				    tableColumnLista.setText(" ");
				    tableConIdLista.getIdColumna().add("");
				    tableColumnLista.pack();
				    tableColumnLista.setAlignment(SWT.CENTER);
					for (int i=0;i<estudiantes.size();i++){
						TableItem fila = tableConIdLista.getObjetoTable().getItem(i);
						int nColumnasNuevas = tiposEvaluable.size()+1+1; //tipos+Tparcial+separador
						for (int j=0;j<nColumnasNuevas;j++) {
							if (j==nColumnasNuevas-2)  {
								String emergenteCelda=
										estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"
										+PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteDatos")+" "+((estudiantes.get(i).get(3)!=null)?estudiantes.get(i).get(3):"");
								tableConIdLista.getEmergente().get(i).add(emergenteCelda);
							} else {tableConIdLista.getEmergente().get(i).add("");}
						}
						Vector<Vector<String>> notas = 
							PCuaderno.MiPCuaderno.bbdd.consultarEvalEvaluablesPorEstudianteEnMateriaClaseParcial(
								estudiantes.get(i).get(0),
								comboConIdMateriaClase.idSeleccionado(),
								nparcial);
						//System.out.println("  \\notas="+notas.size());
						HashMap<String,Double> sumaTipoEvaluable = new HashMap<String,Double>();
						HashMap<String,Double> pesoTipoEvaluable = new HashMap<String,Double>();
						Vector<String> tipoHayMenorMinimo = new Vector<String>();
						if (notas!=null){
							//System.out.println(tableConIdLista.getIdColumna().toString());
							for (int j=0;j<notas.size();j++) {
								int indiceEvaluables=idEvaluables.indexOf(notas.get(j).get(1));
								if (evaluables.get(indiceEvaluables).get(12)==null) {
									Double nota = new Double(notas.get(j).get(2));
									Vector<Vector<String>> recuperaciones = PCuaderno.MiPCuaderno.bbdd.consultarEvaluableRecuperacionesDe(evaluables.get(indiceEvaluables).get(0));
									if (recuperaciones!=null && recuperaciones.size()>0) {
										for (int r=0;r<recuperaciones.size();r++) {
											String resultado = PCuaderno.MiPCuaderno.bbdd.consultarEvalNota(recuperaciones.get(r).get(0), estudiantes.get(i).get(0));
											//System.out.println("resultado="+resultado);
											if (resultado!=null) {
												Double nRecuperacion = new Double(resultado);
												//System.out.println("Nota "+nota+" < "+nRecuperacion+" = "+(nota<nRecuperacion));
												if (nota<nRecuperacion) nota=nRecuperacion;
											}
										}
									}
									String tipo = evaluables.get(indiceEvaluables).get(9);
									//System.out.println("tipo:"+tipo+" nota:"+nota+" minimo:"+tipoMinimo.get(tipo));
									if (tipoHayMenorMinimo.indexOf(tipo)<0) 
										if (tipoMinimo.containsKey(tipo))
											if (nota<tipoMinimo.get(tipo)) tipoHayMenorMinimo.add(tipo);
									Double peso = new Double(evaluables.get(indiceEvaluables).get(8));
									if (sumaTipoEvaluable.containsKey(tipo)){
										sumaTipoEvaluable.put(tipo, sumaTipoEvaluable.get(tipo)+(nota*peso));
										pesoTipoEvaluable.put(tipo, pesoTipoEvaluable.get(tipo)+peso);
									} else {
										sumaTipoEvaluable.put(tipo, (nota*peso)); 
										pesoTipoEvaluable.put(tipo, peso);
									}
								} else {
									boolean esta=false;
									for (int k=0;k<notas.size();k++) if (notas.get(k).get(1).equals(evaluables.get(indiceEvaluables).get(12))) esta=true;
									if (!esta) {
										Vector<String> notaVirtual = new Vector<String>();
										notaVirtual.add("");
										notaVirtual.add(evaluables.get(indiceEvaluables).get(12));
										notaVirtual.add(notas.get(j).get(2));
										notas.add(notaVirtual); // primera cadena = "" ==> notaVirtual (sin nota en el elemento recuperado)
									}
								}
							}
								//System.out.println("tipo ("+tipo+") suma = "+sumaTipoEvaluable.get(tipo)+" peso = "+pesoTipoEvaluable.get(tipo));
						}
						Double sumaTipoEvaluableTotal = new Double(0);
						Double pesoTipoEvaluableTotal = new Double(0);
						boolean tieneAlgunaNota = false;
						if (tiposEvaluable!=null) {
							for (int j=0;j<tiposEvaluable.size();j++){
								int columna=tableConIdLista.getObjetoTable().getColumnCount()-tiposEvaluable.size()-1-1+j; // columnas-tipos-Tparcial-separador
								if (sumaTipoEvaluable.containsKey(tiposEvaluable.get(j).get(0))) {
									Double nota = sumaTipoEvaluable.get(tiposEvaluable.get(j).get(0))/pesoTipoEvaluable.get(tiposEvaluable.get(j).get(0));
									if (tipoHayMenorMinimo.indexOf(tiposEvaluable.get(j).get(0))<0) {
										fila.setText(columna,Numero.cadena(nota));
									    fila.setForeground(columna,
									    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
									    				((nota>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
									    		));
									} else {
										fila.setText(columna,"-");
										fila.setForeground(columna,
								    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
								    				SWT.COLOR_RED
								    		));
									}
									Double peso = new Double(tiposEvaluable.get(j).get(3));
									sumaTipoEvaluableTotal=sumaTipoEvaluableTotal+(nota*peso);
									pesoTipoEvaluableTotal=pesoTipoEvaluableTotal+peso;
									//System.out.println("Total tipo ("+tiposEvaluable.get(j).get(0)+") suma = "+sumaTipoEvaluableTotal+" peso = "+pesoTipoEvaluableTotal);
									tieneAlgunaNota=true;
								}
								tableConIdLista.getEmergente().get(i).set(columna,
										PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteEstudiantes")+" "+estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"+
										PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteTipo")+" "+tiposEvaluable.get(j).get(2)+"\n"+
										PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergentePesoTotal")+" "+Numero.cadenaEntero(Integer.parseInt(tiposEvaluable.get(j).get(3))));
							}
						}
						int columna=tableConIdLista.getObjetoTable().getColumnCount()-1-1; //ultima-separador
						if (tieneAlgunaNota) {
							double notaTotal=sumaTipoEvaluableTotal/pesoTipoEvaluableTotal;
							if (tipoHayMenorMinimo.size()==0) {
								fila.setText(columna,Numero.cadena(notaTotal));
								fila.setForeground(columna,
						    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
						    				((notaTotal>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
						    		));
								sumaParciales.set(i,sumaParciales.get(i)+notaTotal);
							} else {
								hayParcialSuspenso.set(i,true);
								fila.setText(columna,"-");
								fila.setForeground(columna,
						    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
						    				SWT.COLOR_RED
						    		));
								
							}
							notasParciales.set(i,notasParciales.get(i)+1);
						}
					}
					tableConIdLista.getObjetoTable().getColumn(0).pack();
				}
			    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
			    tableColumnLista.setText(PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_TableColumnList_Cabecera_Global"));
			    tableConIdLista.getIdColumna().add("");
			    tableColumnLista.pack();
			    tableColumnLista.setAlignment(SWT.LEFT);
				int columna=tableConIdLista.getObjetoTable().getColumnCount()-1;
				for (int i=0;i<estudiantes.size();i++){
					tableConIdLista.getEmergente().get(i).add(
						estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"+
						PCuaderno.MiPCuaderno.mensajes.getString("GrupoClase_Celda_EmergenteDatos")+
						" "+((estudiantes.get(i).get(3)!=null)?estudiantes.get(i).get(3):""));
					TableItem fila = tableConIdLista.getObjetoTable().getItem(i);
					if (!hayParcialSuspenso.get(i)) {
						double global=sumaParciales.get(i)/notasParciales.get(i);
						fila.setText(columna,Numero.cadena(global));
						fila.setForeground(columna,
				    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
				    				((global>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
				    		));
					} else {
						fila.setText(columna,"-");
						fila.setForeground(columna,
				    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
				    				SWT.COLOR_RED
				    		));
						
					}
				}
			}
		}
	}
}
